/*
    FxFNav (Fenix File Navigator) is a file manager for GP2x Wiz game console.
    Copyright (C) 2009  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

TYPE APP_CONFIG
  int ttt_font	= -1;  // small font
  int ttt_font_b= -1; // bigger font
  int font_size = 12; // base font siz
  
  int font_height   = 10; 
  int font_b_height = 14; 
  
  float activation_scale = 1.4;// how _b fon large than normal
  
  int SW = 320; // screen size
  int SH = 240;
  
  string pipe_cmd = "/dev/shm/fxfnav.cmd";
  string pipe_res = "/dev/shm/fxfnav.res";

  string state_file = "/dev/shm/fxfnav.state";
  string cd_on_exit_file = "/dev/shm/fxfnav.cd";
  string exec_on_exit_file = "/dev/shm/fxfnav.exec";
  
  // skin related
  int TOPPAD = 20;
  
  int map_bg =-1;
  int map_top =-1;
  int map_clock =-1;

  WORD col_bg_general = 0;
  WORD col_bg_emphas  = 0;

  WORD col_normal   = 0;
  WORD col_emphas   = 0;
  WORD col_disabled = 0;
  WORD col_active   = 0;

  WORD col_mp_copy   = 0;
  WORD col_mp_move   = 0;
  WORD col_mp_delete = 0;
  WORD col_file_folder = 0;
  WORD col_file_exe	= 0;
  WORD col_file_link	= 0;

  /// behavior 
  int fps = 30;
  int frameskip = 5;
  int key_thres = 200;
  int use_preview = 1;
  int max_preview_size = 512000;
 
  // do not let follow above this folder
  string lock_folder="/mnt/";
  int lock_folder_navigation = 0;
  int lock_folder_operations = 1;

END

TYPE APP_STATE
  string current_dir = "";
  string current_file = "..";
  string current_stack = "";
  int stack_mode = 0;
END;

FUNCTION LoadConfig(APP_CONFIG *Config, string cfile)
LOCAL
  int fd,i,j,t,l,c[3];
  string line, param, val, tmp;
  WORD  valcolor;
  float valfloat;
  int   valint;
///
  string ttf1,ttf2;
END
BEGIN
  fd = fopen(cfile, O_READ);
  IF(!fd) say("Bad conf: "+cfile); RETURN -1; END;
  
  WHILE(!feof(fd))
    line = fgets(fd);
    l = len(line);
    IF(l==0) CONTINUE;  END;
    IF(line[0]=='/' || line[0]=='#') CONTINUE;  END;
    i = find(line,' ');
    IF(i<0) CONTINUE;  END;
    param = substr(line,0,i);
    FOR(j=i; j<l && line[j]==' '; j++)END;

    /// Convert to every allowed type
    val      = substr(line,j,l-j);
    valint   = atoi(val);
    valfloat = atof(val);
    valcolor = 0;
    tmp = val;
    /// color r,g,b
    FOR(i=0,j=0; i < 3; i++ )
      j = find(tmp,','); // Ну да :)
      IF(j>=0)
	c[i] = atoi(substr(tmp,0,j));
	tmp = substr(tmp,j+1,len(tmp)-j-1);
      ELSE
	c[i] = atoi(tmp);
      END;
      
    END;
    valcolor = rgb(c[0],c[1],c[2]);
    
    SWITCH(param)
      CASE "ttt_font":
	  WHILE( (tmp= glob(val)) != "")
	    ttf1 = fileinfo.path+'/'+fileinfo.name;
	  END;
      END;
      CASE "ttt_font_b":
	  WHILE( (tmp= glob(val)) != "")
	    ttf2 = fileinfo.path+'/'+fileinfo.name;
	  END;
      END;
      CASE "font_size":
	Config.font_size = valint;
      END;
      CASE "activation_scale":
	Config.activation_scale = valfloat;
      END;
      CASE "screen_width":
	Config.SW = valint;
      END;
      CASE "screen_height":
	Config.SH = valint;
      END;
      CASE "pipe_cmd":
	Config.pipe_cmd = val;
      END;
      CASE "pipe_res":
	Config.pipe_res = val;
      END;
      CASE "skin_bg":
	IF(t = load_png(val))
	  IF(Config.map_bg>0) unload_map(0,Config.map_bg); END;
	  Config.map_bg = t;
	END;
      END;
      CASE "skin_top":
	IF(t = load_png(val))
	  IF(Config.map_top>0) unload_map(0,Config.map_top); END;
	  Config.map_top = t;
	END;
      END;
      CASE "skin_clock":
	IF(t = load_png(val))
	  IF(Config.map_clock>0) unload_map(0,Config.map_clock); END;
	  Config.map_clock = t;
	END;
      END;
      CASE "skin_toppad":
	Config.TOPPAD= valint;
      END;
      CASE "col_bg_general":
	Config.col_bg_general = valcolor;
      END;
      CASE "col_bg_emphas":
	Config.col_bg_emphas = valcolor;
      END;
      CASE "col_normal":
	Config.col_normal = valcolor;
      END;
      CASE "col_emphas":
	Config.col_emphas = valcolor;
      END;
      CASE "col_disabled":
	Config.col_disabled = valcolor;
      END;
      CASE "col_active":
	Config.col_active = valcolor;
      END;
      CASE "col_mp_copy":
	Config.col_mp_copy = valcolor;
      END;
      CASE "col_mp_move":
	Config.col_mp_move = valcolor;
      END;
      CASE "col_mp_delete":
	Config.col_mp_delete = valcolor;
      END;
      
      CASE "col_file_folder":
	Config.col_file_folder = valcolor;
      END;
      CASE "col_file_exe":
	Config.col_file_exe = valcolor;
      END;
      CASE "col_file_link":
	Config.col_file_link = valcolor;
      END;
      
      CASE "lock_folder":
	Config.lock_folder = val;
      END;
      CASE "lock_folder_navigation":
	Config.lock_folder_navigation = valint;
      END;
      CASE "lock_folder_operations":
	Config.lock_folder_operations = valint;
      END;

      CASE "fps":
	Config.fps = valint;
      END;      
      CASE "frameskip":
	Config.frameskip = valint;
      END;      
      CASE "key_thres":
	Config.key_thres = valint;
      END;      
      CASE "use_preview":
	Config.use_preview = valint;
      END;      
      CASE "max_preview_size":
	Config.max_preview_size = val;
      END;      
      
    END;
  END;
  
  fclose(fd);
  
  Config.ttt_font   = load_truettf(ttf1,Config.font_size);
  Config.ttt_font_b = load_truettf(ttf2,(int)(Config.font_size * Config.activation_scale+0.5));
  
  // most stupid way to ge font's lineheight 
  t = write_truettf( 0, 0, Config.ttt_font, 0, 0, TT_NEW_MAP, "A");
  IF(t>0)
    Config.font_height = Graphic_info( 0, t, G_HEIGHT );
    unload_map( 0, t );
  END;
  t = write_truettf( 0, 0, Config.ttt_font_b, 0, 0, TT_NEW_MAP, "A");
  IF(t>0)
    Config.font_b_height = Graphic_info( 0, t, G_HEIGHT );
    unload_map( 0, t );
  END;
  RETURN 0;
END;

FUNCTION CHECK_CONFIGURED()
BEGIN
END;

FUNCTION SaveState(APP_STATE s, string fn)
LOCAL
  int f;
END
BEGIN
  f = fopen(fn, O_WRITE);
  // 1
  fputs(f, s.current_dir);
  // 2
  fputs(f, s.current_file);
  // 3
  fputs(f, s.current_stack);
  // 4
  fputs(f, s.stack_mode);
  fclose(f);  
END;

FUNCTION LoadState(APP_STATE *s,  string fn)
LOCAL
  int f;
END
BEGIN
  f = fopen(fn, O_READ);
  IF(!f) RETURN; END;
  // 1
  s.current_dir = fgets(f);
  // 2
  s.current_file = fgets(f);
  // 3
  s.current_stack = fgets(f);
  // 4
  s.stack_mode = fgets(f);
  fclose(f);  
END;

