/*
    FxFNav (Fenix File Navigator) is a file manager for GP2x Wiz game console.
    Copyright (C) 2009  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

CONST
  dialog_max_op = 10;
END

TYPE DIALOG
  string lines[dialog_max_op];
  int keys[dialog_max_op];
  int font =-1;
END;

PROCESS POPDIALOG(DIALOG * d, int *res, int parent_process)
LOCAL
  int i,k,cl,ck;
  int g[dialog_max_op], w, h, lh;
END
BEGIN
  SIGNAL(parent_process, S_SLEEP);
  x = Config.SW/2;
  y = Config.SH/2;
  z = 1;
  
  w = 0;
  h = 0;
  FOR(i=0; d.lines[i]!="" && i<dialog_max_op; i++)
    g[i] = write_truettf(0, 0, d.font, 0, 0, TT_ENC_UTF8 | TT_NEW_MAP, d.lines[i]);
    h += lh = graphic_info( file, g[i], G_HEIGHT);
    k  = graphic_info( file, g[i], G_WIDTH);
    IF( k > w ) w = k; END;
  END;
  cl = i;
  
  graph = new_map( w+10, h+10, 16 );
  map_clear( file, graph, Config.col_bg_general );
  
  k = 5+lh/2;
  FOR( i=0; i<cl; i++ )
    map_put( file, graph, g[i], 5+w/2, k );
    k += lh;
  END;
  
  k = 0;
  LOOP
    FRAME;
    FOR(i=0; d.keys[i] && i<dialog_max_op; i++)
      IF(key(d.keys[i])) 
	k = d.keys[i];
	BREAK; 
      END;
    END;
    IF(k) BREAK; END;
  END;
  
  WHILE(key(k)); FRAME; END;
  *res = k;
  SIGNAL(parent_process, S_WAKEUP);
ONEXIT
  FOR( i=0; i<cl; i++ )
    unload_map(file, g[i]);
  END;  
  unload_map(file,graph);
END;

