/*
    FxFNav (Fenix File Navigator) is a file manager for GP2x Wiz game console.
    Copyright (C) 2009  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

PROCESS Folder_Line(string _full_path, string dispaly_name, int bmap)
PUBLIC
  string full_path;
  string ext;
  //FILE_INFO info;
  int fsize;
  int active = 0, graph1, graph2;
  int prev, nxt, xx, ww, hh, ww2, yto;
  int ds;
BEGIN
  full_path = _full_path;
  //info = _info;
  //size = 70;
  // set_text_color(Config.col_normal); 
  IF(bmap>0)
    graph1 = write_truettf(0, bmap, Config.ttt_font  , 0, 0, TT_ALIGN_H_CENTER | TT_ALIGN_V_MIDDLE | TT_ENC_UTF8, dispaly_name);
  ELSE
    graph1 = write_truettf(0, 0, Config.ttt_font  , 0, 0, TT_NEW_MAP | TT_ENC_UTF8, dispaly_name);
  END;
  
  set_text_color(Config.col_active); 
  graph2 = write_truettf(0, 0, Config.ttt_font_b, 0, 0, TT_NEW_MAP | TT_ENC_UTF8, dispaly_name);
  xx = x;
  graph = graph1;
  ww  = Graphic_info(file,graph1,G_WIDTH );
  hh  = Graphic_info(file,graph1,G_HEIGHT );
  ww2 = Graphic_info(file,graph2,G_WIDTH );
  ds = Config.fps / 4;
  LOOP
    IF(active )
      //flags = B_SBLEND;
      IF(size<100*Config.activation_scale && graph==graph1)
	size +=5; 
	x = xx - ww/2  +(ww/2*size/100);
      ELSE
	graph = graph2;
	x = xx - ww/2  + ww2/2;
	size = 100;
	//say(x+" "+xx);
      END;
    ELSE
      //flags = 0;
      IF(size>100 && graph==graph2)
	size-=5; 
	x = xx - ww/2  +(ww/2*size/100);
      ELSE
	x = xx;
	graph = graph1;
	size = 100;
      END;
    END;
    IF(y < yto) y += ds; END;
    IF(y > yto) y -= ds; END;
    FRAME;
  END;  
ONEXIT
  unload_map( 0, bmap);
  unload_map( file, graph);
  unload_map( file, graph2);
END;

