/*
    FxFNav (Fenix File Navigator) is a file manager for GP2x Wiz game console.
    Copyright (C) 2009  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/
PROGRAM fxfnav;
//      _backspace    _tab
//    u            _z
//  l  r     _ctrl   _alt
//   d            _x
//  _enter      _space
//
CONST
  _WIZ_L = _BACKSPACE;
  _WIZ_R = _TAB;
  _WIZ_MENU = _ENTER;
  _WIZ_SELECT = _SPACE;
  _WIZ_A = _CONTROL;
  _WIZ_B = _ALT;
  _WIZ_X = _X;
  _WIZ_Y = _Z;
END

include "truettf.fh";
include "config.inc.prg";


GLOBAL
  APP_CONFIG Config;
  APP_STATE State;
END

include "locale.inc.prg";
include "dialog.inc.prg";
include "dialogs.inc.prg";
include "commander.inc.prg";
include "list.inc.prg";
include "preview.inc.prg";
include "folderline.inc.prg";
include "manipulator.inc.prg";
include "menu.inc.prg";
include "folder.inc.prg";

LOCAL
  int t;
  string tw;
  DIALOG dia;
  int a;
  int *ap;
END
BEGIN
//   ap =alloc(sizeof(int)*10);
//   ap[2] = a = MenuLineInfo();
//   say(EXISTS(a));
//   say(EXISTS(ap[2]));
//   FRAME;
//   free(ap);
//   signal(a, S_KILL);
//   FRAME;
//   say(EXISTS(a));
//   let_me_alone();
//   RETURN;
  say("FxFNav (Fenix File Navigator) is a file manager for GP2x Wiz game console.");
  say("Copyright (C) 2009  Eugene Popov (popov_e_n@mail.ru)");
  say("This program is free software: you can redistribute it and/or modify "+
"it under the terms of the GNU General Public License as published by "+
"the Free Software Foundation, either version 2 of the License, or "+
"(at your option) any later version.");
  
  // Need for correct color mpping in config
  set_mode(Config.SW, Config.SH, 16);

  LoadConfig(&Config, "fxfnav.conf");
  LoadState(&State, Config.state_file);

  set_mode(Config.SW, Config.SH, 16);
  set_fps(Config.fps, 0);

  put(file,Config.map_bg,Config.SW/2,Config.SH/2);
  
  COMMANDER_INIT(Config.pipe_cmd, Config.pipe_res);
  
  mp_colors[MP_MODE_COPY]   = Config.col_mp_copy;
  mp_colors[MP_MODE_MOVE]   = Config.col_mp_move;
  mp_colors[MP_MODE_DELETE] = Config.col_mp_delete;

  mp_messages[MP_MODE_COPY] = _("COPY SELECTED HERE ?");
  mp_messages[MP_MODE_MOVE] = _("MOVE SELECTED HERE ?");
  mp_messages[MP_MODE_DELETE] = _("DELETE SELECTED ?");
  
  IF(State.current_dir == "")
    State.current_dir  = Config.lock_folder;
    State.current_file =  "..";
  END;
  
 // map_xput(0, Config.map_bg, Config.map_top, Config.SW/2, Config.TOPPAD/2 , 0, 100, 0 );

  say("Starting at: "+State.current_dir+" : "+State.current_file);

  Folder(State.current_dir, State.current_file, -1);

END;

FUNCTION ISSUBDIR(string dir, string subdir)
BEGIN
  RETURN (find(subdir,dir)>=0);
END;

FUNCTION iabs(int s)
BEGIN
  IF(s<0) RETURN -s; END;
  RETURN s;
END;
