#ifndef ALIST_INC
#define ALIST_INC true

PROCESS ALIST_ITEM()
PUBLIC
    int i;
    string s;
    FILE_INFO ifile;
END
BEGIN
  alpha = 0;
  ifile = FILE_INFO();
  SIGNAL(id, S_SLEEP);
  FRAME 10000;
ONEXIT
  IF(EXISTS(ifile)) SIGNAL( ifile, S_KILL ); END;
END;

// list is enumerated from 0, 
// count is current number of elements

TYPE ALIST
  ALIST_ITEM *items;
  int count;
  int alc;  // allocalted
  int slice = 256;
END;

FUNCTION ALIST_NEW(ALIST *l)
BEGIN
  l.items = alloc( sizeof(int) * l.slice);
  l.count = 0;
  l.alc = l.slice;
END;

PROCESS ALIST_FREE(ALIST *l)
PRIVATE 
  int i, n; 
  int *items; 
END
BEGIN
  say('LIST ONEXIT {{');
  n = l.count;
  items = l.items;
  // fast_kill(n, items);
  FOR(i=0;i<n;i++) 
    SIGNAL(items[i], S_KILL);
  END;
  FRAME;
  free(items);
  say('}} LIST ONEXIT');
END;

FUNCTION ALIST_ADD(ALIST *l, /*ALIST_ITEM*/ int item)
LOCAL
  ALIST_ITEM *tmp;
  int i;
END
BEGIN
  IF(l.count==l.alc)
  // extend list
    say("Extending "+l.alc+" to "+(l.alc+l.slice));
    tmp = alloc(sizeof(int/*ALIST_ITEM*/) * (l.alc+l.slice));
    FOR(i=0;i<l.count;i++)
      tmp[i] = l.items[i];

    END;
    free(l.items);
    l.items = tmp;
    l.alc += l.slice;
  END;
  l.items[l.count] = item;
  l.count++;
END;

FUNCTION ALIST_DEL(ALIST *l, int i)
LOCAL
  int k;
END
BEGIN
  IF(i<0 || i>=l.count) RETURN; END;
  // exclude item and shift tail
  FOR(k=i; k<l.count-1; k++)
    l.items[k] = l.items[k+1];
  END;
  l.count--;
END;

FUNCTION ALIST_DMP(ALIST *l)
LOCAL
  int i;
END
BEGIN
  FOR(i=0;i<l.count;i++)
    say(i+") "+l.items[i].s);
  END;
END;

#endif