
TYPE MenuStyle
  word color1;
  word color2;
  int  font1;
  int  font2;
  int  movestyle;
  int  line_height;
END;

PROCESS MenuLineInfo ()
PUBLIC
  word color;
  string caption = "";
  string value = ""; 
  int key;
  int icon;
END
BEGIN
  alpha = 0;
  SIGNAL(id, S_SLEEP);
  FRAME RAND(100,10000);
/*ONEXIT
  SAY('MENULINEINFO '+id+' '+caption+' ONEXIT');*/
END;

FUNCTION CPY_MENULINEINFO(int tg, int sr)
LOCAL
  MenuLineInfo targ;
  MenuLineInfo source;
END
BEGIN
  targ = tg;
  source = sr;

  targ.color	= source.color;
  targ.caption	= source.caption;
  targ.value	= source.value; 
  targ.key	= source.key;
  targ.icon	= source.icon;
END;

#define MENU_CMD_NOP	0
#define MENU_CMD_UP	1
#define MENU_CMD_DOWN	2
#define MENU_CMD_PGUP	3
#define MENU_CMD_PGDOWN	4
#define MENU_CMD_EXIT	5
#define MENU_CMD_REFRESH 6

// PROCESS Menu_Line(string _full_path, string dispaly_name, FILE_INFO _info, int bmap)
// PUBLIC
//   string full_path;
//   string ext;
//   FILE_INFO info;
//   int fsize;
//   int active = 0, graph1, graph2;
//   int prev, nxt, xx, ww, hh, ww2, yto;
//   int ds;
// BEGIN
// ONEXIT
// END;

PROCESS MenuLineObject()
LOCAL
  MenuLineInfo inf;
  //string caption;
  MenuStyle *mstyle;
  int lastmode, lastkey;
  int mode; // 0 - normal, 1 - active, 2 - empty
  int phase;
  int phtype; // change type 0=0->1, 1=1->0
  int g1 =-1, g2 =-1, g11 =-1 , w1, w2;
  int bx;
  int by, lsh;
  word c1;
END
BEGIN
    lastmode = 0;
    mode  = 0;
    phase = 0;

    SIGNAL(id, S_SLEEP);
    FRAME;
    /// let owner change mode to desired
  
    IF(!EXISTS(inf)) 
      SAY('WARN: inf gone before init.');
      RETURN; 
    END;

    IF (inf.color) c1 = inf.color; ELSE c1 = mstyle.color1; END;
    
    set_text_color(c1); 
    graph = g1 = write_truettf(0, 0, mstyle.font1  , 0, 0, TT_NEW_MAP | TT_ENC_UTF8, inf.caption);
    set_text_color(mstyle.color2); 
    g11 = write_truettf(0, 0, mstyle.font1  , 0, 0, TT_NEW_MAP | TT_ENC_UTF8, inf.caption);
    g2 = write_truettf(0, 0, mstyle.font2  , 0, 0, TT_NEW_MAP | TT_ENC_UTF8, inf.caption);
    w1 = Graphic_info( file, g1, G_WIDTH );
    w2 = Graphic_info( file, g2, G_WIDTH );
    lsh = 0;
    LOOP
      x = bx + (w1 + lsh)/2;
      y = by;
      FRAME 50;

      IF(!EXISTS(inf)) 
	SAY('WARN: inf gone on refresh');
	RETURN;
      END;

      IF(mode!=lastmode || lastkey != inf.key)
	IF(lastkey != inf.key)
	  IF(g1 >0) unload_map(file, g1); END;
	  IF(g11>0) unload_map(file, g11); END;
	  IF(g2 >0) unload_map(file, g2); END;
	  IF (inf.color) c1 = inf.color; ELSE c1 = mstyle.color1; END;
	  set_text_color(c1); 
	  g1 = write_truettf(0, 0, mstyle.font1  , 0, 0, TT_NEW_MAP | TT_ENC_UTF8, inf.caption);
	  set_text_color(mstyle.color2); 
	  g11 = write_truettf(0, 0, mstyle.font1  , 0, 0, TT_NEW_MAP | TT_ENC_UTF8, inf.caption);
	  g2 = write_truettf(0, 0, mstyle.font2  , 0, 0, TT_NEW_MAP | TT_ENC_UTF8, inf.caption);
	  w1 = Graphic_info( file, g1, G_WIDTH );
	  w2 = Graphic_info( file, g2, G_WIDTH );
	  graph = g1;
	  phase = 0;
	END;
	
	IF(mode==2)
	  graph = 0;
	  phase = 0;
	ELSE
	  IF( lastmode==1 && mode == 0 )
	    phtype = 1;
	    IF(phase==0) phase  = 15; END;
	  END;
	  IF( /*lastmode==0 &&*/ mode == 1 ) 
	    phtype = 0;
	    IF(phase==0) phase  = 15; END;
	  END;
	END;
      END;
      
      IF(phase>0)
        //say(inf.caption+": "+lsh);
	IF(phtype==0)
	  phase--;
	  IF(phase>0)
	    graph = g11;
	    size = 100 * (w1 + (15- phase) * (w2-w1) /15 ) / w1;
	    lsh  = (w2-w1) * size /200;
	  ELSE
	    graph = g2;
	    size = 100;
	    lsh  = (w2-w1);
	  END;
	ELSEIF(phtype==1)
	  phase--;
	  IF(phase>0)
	    graph = g1;
	    size = 100 * ( w1 + phase * (w2-w1) /15 ) / w1;
	    lsh  = (w2-w1) * size /200;
	  ELSE
	    graph = g1;
	    size = 100;
	    lsh  = 0;
	  END;
	END;
      END;
      
      lastmode = mode;
      lastkey  = inf.key;      
    END;
ONEXIT
  //SAY("MENUITEM "+id+" ONEXIT");
  //IF(EXISTS(inf)) SIGNAL(inf,S_KILL); END;
  IF(g1 >0) unload_map(file, g1); END;
  IF(g11>0) unload_map(file, g11); END;
  IF(g2 >0) unload_map(file, g2); END;
END;

/*
Menu itself
*/
PROCESS MenuObject(MenuStyle xstyle, int mw, int mh, int mz)
LOCAL
  int fr_w = 320, fr_h = 240, fr_lh = 10;
  int i, icnt =0 , pcnt;
  MenuLineObject *items;
  MenuLineInfo *iinf;
  MenuStyle mstyle;
  int itop, iactive;
  int fix;
END
PUBLIC
  int command;
  MenuLineInfo selected;
  MenuLineObject selected_g;
END
BEGIN
  mstyle.font1 = xstyle.font1;
  mstyle.font2 = xstyle.font2;
  mstyle.color1 = xstyle.color1;
  mstyle.color2 = xstyle.color2;
  mstyle.line_height = xstyle.line_height;

  SAY('MENU '+id);
  SIGNAL(id, S_SLEEP);
  FRAME;
// icnt, items & iinf should be set by external procees before wakeup
// at this point
  ;

  IF(icnt <= 0 )
    SAY('ERROR. Menu count <=0 '+icnt);
    EXIT(1);
  END;

  fr_w = mw;
  fr_h = mh;
  z = mz;

//  icnt = cnt;
  items = alloc( icnt*sizeof(int/*MenuLineObject*/) );
//  iinf  = alloc( cnt*sizeof(int/*MenuLineInfo*/) );
  fr_lh  = mstyle.line_height;
  pcnt = fr_h / fr_lh + 2; // items on a page

  graph = new_map(fr_w, fr_h ,16);
  
//   FOR(i=0;i<icnt;i++)
//     iinf[i]= MenuLineInfo();
//     CPY_MENULINEINFO(iinf[i], ifo[i]);
//     SIGNAL(ifo[i], S_KILL);
//   END;

  FOR(i=0;i<pcnt && i<icnt ;i++)
    items[i] = MenuLineObject();
    items[i].inf = iinf[i];
    items[i].mode = 2;
    items[i].mstyle = &mstyle;
    SIGNAL(items[i], S_WAKEUP);
  END;

//  selected = iinf[0];
  selected_g = items[0];
  
//  itop    = 0;
//  iactive = 0;
  fix     = fr_lh/2;
  
  command = MENU_CMD_NOP;
  FRAME;
  
  LOOP
    SAY('MENU LOOP ');
  
    IF(iactive<0) iactive = 0; END;
    IF(iactive>=icnt) iactive = icnt-1; END;
    
    IF(iactive < itop ) itop = iactive; END;
    IF(iactive >= itop + pcnt ) itop = iactive - pcnt+1; END;
    
    selected = iinf[iactive];
    selected_g = items[iactive];
    
    fix = 0;
    SAY('FOR iactive '+icnt+' '+pcnt);
    FOR(i=0; i<icnt && i < pcnt; i++)
      IF(itop+i<icnt)
	items[i].inf = iinf[itop+i];
	items[i].mode = 0;
      ELSE
	items[i].mode = 2;	
      END;
      IF(itop+i == iactive) items[i].mode = 1; END;
      items[i].bx = x - fr_w/2;
      items[i].by = y - fr_h/2 + fr_lh * i;
      items[i].z = z;
    END;
    
    command = MENU_CMD_NOP;
    SAY('COMMAND LOOP');
    LOOP
      
      IF(items[iactive-itop].by + fr_lh/2 > y + fr_h/2 )
	fix --;
	FOR(i=0; i<icnt && i < pcnt; i++)
	  items[i].by = y - fr_h/2 + fr_lh * i + fix;
	END;
      END;
      IF(items[iactive-itop].by - fr_lh/2 < y - fr_h/2 )
	fix ++;
	FOR(i=0; i<icnt && i < pcnt; i++)
	  items[i].by = y - fr_h/2 + fr_lh * i + fix;
	END;
      END;
      
      IF(command == MENU_CMD_UP && iactive>0 )
	iactive--;
	BREAK;
      END;
      IF(command == MENU_CMD_DOWN && iactive<icnt-1 )
	iactive++;
	BREAK;
      END;
      IF(command == MENU_CMD_PGUP && iactive>0 )
	iactive-= (pcnt-2);
	BREAK;
      END;
      IF(command == MENU_CMD_PGDOWN && iactive<icnt-1 )
	iactive+=(pcnt-2);
	BREAK;
      END;
      IF(command == MENU_CMD_REFRESH)
	BREAK;
      END;
      IF(command == MENU_CMD_EXIT)
	RETURN;
      END;
      
      command = MENU_CMD_NOP;
      FRAME;
    END;
  END;  
ONEXIT
  SAY("MENU "+id+" DESTROYED {{");
  FOR(i=0; i<icnt && i < pcnt ;i++)
    IF(EXISTS(items[i])) signal(items[i], S_KILL); END;
  END;
/*  FOR(i=0; i<icnt ;i++)
    IF(EXISTS(iinf[i])) signal(iinf[i], S_KILL); END;
    IF(!i%10) FRAME; END;
  END;*/
  free(items);
//  free(iinf);
  SAY("}} MENU DESTROYED ");
END;

FUNCTION MenuFromItemInfoList(ALIST *iteminfo, MenuStyle xstyle, int mw, int mh, int mz)
LOCAL
  MenuObject m, i;
END
BEGIN
  m = MenuObject( xstyle, mw, mh, mz);
  m.iinf = iteminfo.items;
  m.icnt = iteminfo.count;

  m.selected = m.iinf[0];
  //m.selected_g = m.items[0];  
  m.itop    = 0;
  m.iactive = 0;

  SIGNAL(m, S_WAKEUP);
  RETURN m;
END;
